;;;; srfi-27-cauchys.scm
;;;; Kon Lovett, Dec '17
;;;; Kon Lovett, Jun '17
;;;; Kon Lovett, May '06

; Chicken Generic Arithmetic! (could use fp routines)

(module srfi-27-cauchys

(;export
  *make-random-cauchys
  make-random-cauchys)

(import scheme chicken)

(use
  (only type-errors error-argument-type)
  (only type-checks
    define-check+error-type
    check-procedure
    check-cardinal-integer
    check-real
    check-open-interval
    check-closed-interval)
  srfi-27
  srfi-27-distributions-support)

;;; Cauchy distribution

(define (*make-random-cauchys median sigma randoms)
  (lambda ()
    (+ median (* sigma (tan (* *pi* (- (randoms) 0.5)))))) )

(define (make-random-cauchys #!key (median 0.0) (sigma 1.0) (randoms (random-real/current)))
  (check-real 'make-random-cauchys median 'median)
  (check-positive-real 'make-random-cauchys sigma 'sigma)
  (check-procedure 'make-random-cauchys randoms 'randoms)
  (values
    (*make-random-cauchys median sigma randoms)
    (lambda () (values median sigma randoms))) )

) ;module srfi-27-cauchys
